#include <iostream>
#include <string.h>
#include <sys/types.h>
//#include <sys/socket.h>
//#include <netdb.h>
//#include <unistd.h>
#include <errno.h>
#include <cstdlib>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>   
#define MAXHOSTNAME 256

#define PWM_MAX 65537

#define CTRL_OFST 0
#define PWM_A_OFST 0x4
#define PWM_B_OFST 0x10
#define SYNC_A_OFST 0x1C
#define SYNC_B_OFST 0x20

#define RUN_BIT 0
#define DIR_A_BIT 1
#define DIR_B_BIT 9
#define SYNC_BIT 7

using namespace std;

struct data_packet {
   uint32_t ctrl;
   uint32_t pwm;
   uint32_t syncA;
   uint32_t syncB;
};

bool sigpipeErr = false;

/// Ignore signal with this handler
void handleSigpipe(int signum)
{
   cout << "SIGPIPE ignored" << endl;
   sigpipeErr = true;
   return;
}

main()
{
   struct sockaddr_in remoteSocketInfo;
   struct hostent *hPtr;
   int socketHandle;
   char *remoteHost="192.168.10.86";
   int portNumber = 8765;  
   struct data_packet data;
	data.pwm = 0;
	data.ctrl = 0;
	data.syncA = 1;
	data.syncB = 1;

   /// Ignore SIGPIPE "Broken pipe" signals when socket connections are broken.
   signal(SIGPIPE, handleSigpipe);
   sigpipeErr = false;
   bzero(&remoteSocketInfo, sizeof(sockaddr_in));  // Clear structure memory

   // Get system information

   if((hPtr = gethostbyname(remoteHost)) == NULL)
   {
      cerr << "System DNS name resolution not configured properly." << endl;
      cerr << "Error number: " << ECONNREFUSED << endl;
      exit(EXIT_FAILURE);
   }

   // create socket

   if((socketHandle = socket(AF_INET, SOCK_STREAM, 0)) < 0)
   {
      close(socketHandle);
      exit(EXIT_FAILURE);
   }

   // Load system information into socket data structures

   memcpy((char *)&remoteSocketInfo.sin_addr, hPtr->h_addr, hPtr->h_length);
   remoteSocketInfo.sin_family = AF_INET;
   remoteSocketInfo.sin_port = htons((u_short)portNumber);      // Set port number

   cout << "Socket Created!" << endl;
   if(connect(socketHandle, (struct sockaddr *)&remoteSocketInfo, sizeof(sockaddr_in)) < 0)
   {
      close(socketHandle);
      exit(EXIT_FAILURE);
   }
   cout << "Socket connected!" << endl;

   int rc = 0;  

bool done = false;
char input;
uint32_t pwmVal = 0;

while (!done && !sigpipeErr)
{
   cout << "Enter a control character: ";
   input = getchar();
   cout << input << endl;
   
    switch (input)
    {
    case 'w':
    	if (pwmVal < 10)
    		pwmVal++;
    	data.ctrl |= (0 << RUN_BIT) | (0 << DIR_A_BIT) | (0 << DIR_B_BIT) | (1 << SYNC_BIT);
    	break;
    case 's':
    	if (pwmVal > 0)
    		pwmVal--;
    	data.ctrl |= (0 << RUN_BIT) | (0 << DIR_A_BIT) | (0 << DIR_B_BIT) | (1 << SYNC_BIT);
    	break;
    case '8':
    	data.ctrl |= (1 << RUN_BIT) | (0 << DIR_A_BIT) | (1 << DIR_B_BIT) | (1 << SYNC_BIT);
    	data.ctrl &= ~((0 << RUN_BIT) | (1 << DIR_A_BIT) | (0 << DIR_B_BIT) | (0 << SYNC_BIT));
    	data.syncA = 1;
    	data.syncB = 1;
    	break;
    case '2':
    	data.ctrl |= (1 << RUN_BIT) | (1 << DIR_A_BIT) | (0 << DIR_B_BIT) | (1 << SYNC_BIT);
    	data.ctrl &= ~((0 << RUN_BIT) | (0 << DIR_A_BIT) | (1 << DIR_B_BIT) | (0 << SYNC_BIT));
    	data.syncA = 1;
    	data.syncB = 1;
    	break;
    case '4':
    	data.ctrl |= (1 << RUN_BIT) | (1 << DIR_A_BIT) | (1 << DIR_B_BIT) | (1 << SYNC_BIT);
    	data.ctrl &= ~((0 << RUN_BIT) | (0 << DIR_A_BIT) | (0 << DIR_B_BIT) | (0 << SYNC_BIT));
    	data.syncA = 1;
    	data.syncB = 1;
    	break;
    case '6':
    	data.ctrl |= (1 << RUN_BIT) | (0 << DIR_A_BIT) | (0 << DIR_B_BIT) | (1 << SYNC_BIT);
    	data.ctrl &= ~((0 << RUN_BIT) | (1 << DIR_A_BIT) | (1 << DIR_B_BIT) | (0 << SYNC_BIT));
    	data.syncA = 1;
    	data.syncB = 1;
    	break;
    case '5':
    	data.ctrl &= ~((1 << RUN_BIT) | (0 << DIR_A_BIT) | (0 << DIR_B_BIT) | (0 << SYNC_BIT));
    	data.syncA = 1;
    	data.syncB = 1;
    	break;
    case 'q':
    	data.ctrl &= ~((1 << RUN_BIT) | (0 << DIR_A_BIT) | (0 << DIR_B_BIT) | (0 << SYNC_BIT));
      done = true;
      break;
    }
    data.pwm = pwmVal * (PWM_MAX / 10);
      cout << "writing ctrl=" << data.ctrl << " syncA=" << data.syncA << " syncB=" << data.syncB << " pwm=" << data.pwm << endl;
       send(socketHandle, &data, sizeof(data), 0);
}
}

          
